#include <bits/stdc++.h>

#include <utility>

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double
#define ckmin(a, b) a = min(a, b)
#define ckmax(a, b) a = max(a, b)
#define int long long

struct Q {
    vector<int> res;

    Q(vector<int> res) : res(std::move(res)) {}

    Q() {}
};

struct Point {
    int x, y;

    Point(int x, int y) : x(x), y(y) {}

    Point() {}
};

int vec(Point &a, Point &b) {
    return a.x * b.y - a.y * b.x;
}

int scal(Point &a, Point &b) {
    return a.x * b.x + a.y * b.y;
}

Point operator+(Point a, Point b) {
    return {a.x + b.x, a.y + b.y};
}

Point operator-(Point a) {
    return {-a.x, -a.y};
}

Point operator-(Point a, Point b) {
    return a + (-b);
}

vector<vector<Point>> triangles;
int n;

void solve3() {
    cout << n * (n - 1) * (n - 2) * (n - 3) / 4 / 3 / 2 << '\n';
    for (int i = 1; i <= n; ++i) {
        for (int j = i + 1; j <= n; ++j) {
            for (int k = j + 1; k <= n; ++k) {
                for (int q = k + 1; q <= n; ++q) {
                    cout << i << " " << j << " " << k << " " << q << '\n';
                }
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t;
    cin >> t >> n;
    triangles.resize(n, vector<Point>(3));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < 3; ++j) {
            cin >> triangles[i][j].x >> triangles[i][j].y;
        }
    }

    if (t == 3)solve3();
}