#include <bits/stdc++.h>

#include <utility>

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double
#define ckmin(a, b) a = min(a, b)
#define ckmax(a, b) a = max(a, b)
#define int long long

struct Point {
    int x, y;

    Point(int x, int y) : x(x), y(y) {}

    Point() {}

    int len2() const {
        return x * x + y * y;
    }
};

int vec(Point &a, Point &b) {
    return a.x * b.y - a.y * b.x;
}

int scal(Point &a, Point &b) {
    return a.x * b.x + a.y * b.y;
}

Point operator+(Point a, Point b) {
    return {a.x + b.x, a.y + b.y};
}

Point operator-(Point a) {
    return {-a.x, -a.y};
}

Point operator-(Point a, Point b) {
    return a + (-b);
}

vector<vector<Point>> triangles;
int n;

void solve3() {
    cout << n * (n - 1) * (n - 2) * (n - 3) / 4 / 3 / 2 << '\n';
    for (int i = 1; i <= n; ++i) {
        for (int j = i + 1; j <= n; ++j) {
            for (int k = j + 1; k <= n; ++k) {
                for (int q = k + 1; q <= n; ++q) {
                    cout << i << " " << j << " " << k << " " << q << '\n';
                }
            }
        }
    }
}

Point get(Point &a, Point &b) {
    return (b - a);
}

void solve4_5() {
    map<int, vector<int>> idx;
    for (int i = 0; i < n; ++i) {
        auto v1 = get(triangles[i][0], triangles[i][1]);
        auto v2 = get(triangles[i][1], triangles[i][2]);
        auto v3 = get(triangles[i][0], triangles[i][2]);
        int hyp = max({v1.len2(), v2.len2(), v3.len2()});
        idx[hyp].push_back(i);
    }

    vector<vector<int>> res;
    for (auto &t: idx) {
        auto v = t.second;
        for (int i = 0; i < (int) v.size(); ++i) {
            for (int j = i + 1; j < (int) v.size(); ++j) {
                for (int k = j + 1; k < (int) v.size(); ++k) {
                    for (int q = k + 1; q < (int) v.size(); ++q) {
                        res.push_back({v[i] + 1, v[j] + 1, v[k] + 1, v[q] + 1});
                        sort(all(res.back()));
                    }
                }
            }
        }
    }

    sort(all(res));
    res.erase(unique(all(res)), res.end());

    cout << res.size() << '\n';
    for(auto &t : res){
        for(int x : t)cout << x << " ";
        cout << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t;
    cin >> t >> n;
    triangles.resize(n, vector<Point>(3));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < 3; ++j) {
            cin >> triangles[i][j].x >> triangles[i][j].y;
        }
    }

    if (t == 3) {
        solve3();
    } else if (t >= 4 && t <= 5) {
        solve4_5();
    } else {
        vector<vector<int>> res;

        for (int mid = 0; mid < n; ++mid) {
            for (int t1 = 0; t1 < n; ++t1) {
                for (int t2 = 0; t2 < n; ++t2) {
                    for (int t3 = 0; t3 < n; ++t3) {
                        set<int> vals;
                        vals.insert(t1);
                        vals.insert(t2);
                        vals.insert(t3);
                        vals.insert(mid);
                        if (vals.size() != 4)continue;

                        for (int side1 = 0; side1 < 3; ++side1) {
                            for (int side2 = 0; side2 < 3; ++side2) {
                                for (int side3 = 0; side3 < 3; ++side3) {

                                }
                            }
                        }
                    }
                }
            }
        }
    }
}