#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double
#define ckmax(a, b) a = max(a, b)
#define ckmin(a, b) a = min(a, b)
#define int long long

const ld eps = 1e-9;

bool comp(ld x, ld y) {
    return abs(x - y) < eps;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, q;
    cin >> n >> q;

    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i)cin >> a[i];
    for (int i = 0; i < n; ++i)cin >> b[i];
    sort(all(a));
    sort(rall(b));

    while (q--) {
        int c;
        cin >> c;

        ld l = 0.0, r = 1000001.0;
        for (int it = 0; it < 200; ++it) {
            ld m = (l + r) / 2.0;
            int cnt = 0;

            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < n; ++j) {
                    if ((ld) a[i] <= m * (ld) b[j])cnt++;
                }
            }

            if (cnt >= c)r = m;
            else l = m;
        }

        ld d = (l + r) / 2.0;
        int ii = -1, jj = -1;

        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                if (((ld) a[i] >= d * (ld) b[j] || comp(a[i], d * (ld)b[j]))&&
                    (ii == -1 || a[ii] * b[j] > a[i] * b[jj])) {
                    ii = i, jj = j;
                }
            }
        }

        assert(ii != -1);
        int x = a[ii], y = b[jj];
        int g = __gcd(x, y);
        cout << x / g << " " << y / g << '\n';
    }
}
