#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double
#define ckmax(a, b) a = max(a, b)
#define ckmin(a, b) a = min(a, b)
#define int long long

int n, k;
vector<vector<pair<int, int>>> g;
vector<vector<pair<int, int>>> dp;
const int inf = 1e9;

pair<int, int> operator+(pair<int, int> a, pair<int, int> b) {
    return {a.first + b.first, a.second + b.second};
}

//0 < k 1 - k
void dfs(int v, int p = -1) {
    dp[v][0] = {0, 0};

    vector<pair<int, int>> d1, d2;
    for (auto &U: g[v]) {
        int u = U.first, w = U.second;
        if (u == p)continue;

        dfs(u, v);
        d1.emplace_back(dp[u][0].first + 1, dp[u][0].second + w);
        d2.emplace_back(max(dp[u][0], dp[u][1]));
    }
//    int sz = (int) d1.size();
//    vector<vector<pair<int, int>>> fdp(sz, vector<pair<int, int>>(k + 1, {inf, inf}));
//    fdp[0][0] = d2[0];
//    fdp[0][1] = d1[0];
//
//    for (int i = 1; i < sz; ++i) {
//        for (int t = 0; t <= k; ++t) {
//            if (t > 0 && fdp[i - 1][t - 1].first != -inf) {
//                ckmax(fdp[i][t], fdp[i - 1][t - 1] + d1[i]);
//            }
//            ckmax(fdp[i][t], fdp[i - 1][t] + d2[i]);
//        }
//    }
//
//    for (int t = 0; t < k; ++t)ckmax(dp[v][0], fdp[sz - 1][t]);
//    dp[v][1] = fdp[sz - 1][k];
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> k;
    g.resize(n);
    vector<pair<int, int>> edges;

    cout << "java" << endl;
    for (int i = 1; i < n; ++i) {
        int p, w;
        cin >> p >> w;
        g[--p].push_back({i, w});
        g[i].push_back({p, w});
        edges.emplace_back(p, w);
    }

    dp.resize(n, vector<pair<int, int>>(2, {-inf, -inf}));
    dfs(0);

    auto q = max(dp[0][0], dp[0][1]);
    cout << q.first << " " << -q.second;
}
//8 2
//1 0
//1 0
//1 0
//2 0
//2 0
//2 0
//1 0